﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Data.Extensions;
using Syncfusion.Data;
namespace SfDataGridSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {        
        public MainWindow()
        {
            InitializeComponent();
        }
    }
  
    public class CustomComparer : IComparer<object>, ISortDirection
    {
        public int Compare(object x, object y)
    {
        int namX;
        int namY;

     
        ////While sorting groups
         if (x.GetType() == typeof(Group))
         {
             //Calculating the group key length
             namX = ((Group)x).Key.ToString().Length;
             namY = ((Group)y).Key.ToString().Length;
         }

         else
         {
             namX = x.ToString().Length;
             namY = y.ToString().Length;
         }

        ////returns the comparison result based in SortDirection.
         if (namX.CompareTo(namY) > 0)
             return SortDirection == ListSortDirection.Ascending ? 1 : -1;

         else if (namX.CompareTo(namY) == -1)
             return SortDirection == ListSortDirection.Ascending ? -1 : 1;

         else
             return 0;
    }

        //Get or set the direction of sorting when compared gets called.
        private ListSortDirection _SortDirection;

        public ListSortDirection SortDirection
        {
            get { return _SortDirection; }
            set { _SortDirection = value; }
        }
    }
}
