﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridSample
{
    public class EmployeeInfoRespository
    {
        Random r = new Random();

        public DataTable CreateEmployeeDataTable()
        {
            var employees = new DataTable();
            employees.Columns.Add("EmployeeID", typeof(int));
            employees.Columns.Add("Name");
            employees.Columns.Add("NationalIDNumber", typeof(long));
            employees.Columns.Add("ContactID", typeof(int));
            employees.Columns.Add("Count", typeof(int));
            employees.Columns.Add("ManagerID", typeof(int), "(EmployeeID + ContactID)");
            return employees;
        }
        public DataTable GetEmployeesDetails_DataTable(int count)
        {
            var employees = CreateEmployeeDataTable();
            for (var i = 1; i < 30; i++)
            {
                var row = GetEmployeeForDT(i, employees);
                employees.Rows.Add(row);
            }
            return employees;
        }

        public DataRow GetEmployeeForDT(int i, DataTable employees)
        {
            int j = i;
            if (j > 20) j = 0;
            var row = employees.NewRow();
            var name = employeeName[j];
            if (i % 5 == 0)
            {
                row[0] = 1000 + i;
            }
            row[1] = name;
            row[2] = 100 + i;
            row[3] = 1 + i;
            return row;
        }
      
        private string[] employeeName = new string[]
            {
                "Sean Jacobson",
                "Phyllis Allen",
                "Marvin Allen",
                "Michael Allen",
                "Cecil Allison",
                "Oscar Alpuerto",
                "Sandra Altamirano",
                "Selena Alvarad",
                "Emilio Alvaro",
                "Maxwell Amland",
                "Mae Anderson",
                "Ramona Antrim",
                "Sabria Appelbaum",
                "Hannah Arakawa",
                "Kyley Arbelaez",
                "Tom Johnston",
                "Thomas Armstrong",
                "John Arthur",
                "Chris Ashton",
                "Teresa Atkinson",
                "John Ault",
                "Robert Avalos",
                "Stephen Ayers",
                "Phillip Bacalzo",
                "Gustavo Achong",
                "Catherine Abel",
                "Kim Abercrombie",
                "Humberto Acevedo",
                "Pilar Ackerman",
                "Frances Adams",
                "Margar Smith",
                "Carla Adams",
                "Jay Adams",
                "Ronald Adina",
                "Samuel Agcaoili",
                "James Aguilar",
                "Robert Ahlering",
                "Francois Ferrier",
                "Kim Akers",
                "Lili Alameda",
                "Amy Alberts",
                "Anna Albright",
                "Milton Albury",
                "Paul Alcorn",
                "Gregory Alderson",
                "J. Phillip Alexander",
                "Michelle Alexander",
                "Daniel Blanco",
                "Cory Booth",
                "James Bailey"
            };
    }
}
